      subroutine abfind
c******************************************************************************
c     This routine derives abundances for individual atomic lines       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      character choice
      integer sm_device

c*****read the parameter file
      call params

c*****set up the output file
      nwrite = 20     
c     array = 'Give the filename for standard output: '
c     nchars = 39
c     call infile ('output ',nwrite,'formatted  ',0,nchars,4)
   
c  AMcW 12/Aug/2003
      open(unit=nwrite,file='logfile')

      ndump = 21     
c     array = 'Give the filename for abundance summaries: '
c     nchars = 43
c     call infile ('output ',ndump,'formatted  ',0,nchars,6)

c  AMcW 12/Aug/2003
      open(unit=ndump,file='OUTPUT')


c*****set up the model atmosphere                                        
      filemodel = 30
c     array = 'Give the filename for the model atmosphere: '
c     nchars = 44
c     call infile ('input  ',filemodel,'formatted  ',0,nchars,8)

c  AMcW 12/Aug/2003
      open(unit=filemodel,file='MODEL')

      call inmodel

c*****read line data; get ready for the line calculations
      filelines = 31
c     array = 'Give the filename for the line list: '
c     nchars = 37
c     call infile ('input  ',filelines,'formatted  ',0,nchars,10)

c  AMcW 12/Aug/2003
      open(unit=filelines,file='INPUT')

      call inlines (1)
      call eqlib
      call nearly
 
c*****set some parameters
      call out (24)
      ipr(5) = -1
      mode = 2

c*****find the range of lines of a species
5     call linlimit
      if (lim1line .lt. 0) then
         call finish
         return
      endif
      lim1obs = lim1line
      lim2obs = lim2line

c*****force each abundance of a species member to predict the 
c     line equivalent width
10    do lim1=lim1line,lim2line
         lim2 = lim1
         ncurve = 1
         gf1(ncurve) = gf(lim1)
         rwlgobs = dlog10(width(lim1)/wave1(lim1))
15       call oneline (2)
         error = (w(ncurve)-width(lim1))/width(lim1)
         ratio = width(lim1)/w(ncurve)
         ncurve = ncurve + 1

c*****here we go for another iteration on a line
         if (dabs(error) .ge. 0.0025) then
            rwlcomp = dlog10(w(ncurve-1)/wave1(lim1))
            if     (rwlcomp.lt.-5.2 .and. rwlgobs.lt.-5.2) then 
               ratio = ratio
            elseif (rwlcomp.ge.-5.2 .and. rwlgobs.ge.-5.2) then 
               ratio = ratio**2.0
            else   
               ratio = ratio**1.5
            endif
            gf1(ncurve) = gf1(ncurve-1)*ratio
            do i=1,ntau                                
               kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
            enddo
            go to 15

c*****here we do the final calculation on a line when the predicted 
c     and observed are close enough to finish
         else
            gf1(ncurve) = gf1(ncurve-1)*ratio
            do i=1,ntau                                                     
               kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
            enddo
            call oneline (1)
            widout(lim1) = w(ncurve)
            diff = dlog10(gf1(ncurve)/gf(lim1))
            if (atom1(lim1) .ge. 100.) then
               abunout(lim1) = diff
            else
               abunout(lim1) = dlog10(xabund(int(atom1(lim1)))) + 
     .                         12.0 + diff
            endif
            call out (24)
         endif
      enddo

c*****get the average and standard deviation, and trend parameters for
c     this species; print out results
c
c curt mode AMcW 1/2000
      if (curt) then
         call out(29)
      else
         call stats
         call out (25)
      endif

c*****here a plot may be made on the terminal (and paper) if there 
c     are enough lines
      if (kount .ge. ipr(7) .and. ipr(7) .ne. 0) then
55       choice = 'y'
         if (sm_device(smterm) .lt. 0) then
            write (nwrite,1006) smterm
1006        format ('DEVICE OPENING ERROR FOR:',a54)
            stop
         endif
         call sm_graphics
         call sm_erase
         call linplot (choice)
         call sm_gflush
         call sm_alpha
         array = '   MAKE A HARDCOPY OF THIS PLOT ([n]/h/f/r)? '
         ikount = kount + 11
         nchars = 45
         call getasci (nchars,ikount)
         choice = chinfo(1:1)
         if (choice.eq.'n' .or. nchars.le.0) then
            go to 60
         elseif (choice .eq. 'h') then
            if (sm_device('postport') .lt. 0) then
               write (nwrite,1008) 
1008           format ('DEVICE OPENING ERROR FOR: postport')
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         elseif (choice .eq. 'r') then
            go to 55
         elseif (choice .eq. 'f') then
            array = 
     .        'Give the file name for the POSTSRIPT plot image: '
            nchars = 49
            ikount = kount + 12
            call getasci (nchars,ikount)
            write (array,1005) chinfo(1:nchars)
1005        format ('postfile ',a71)
            if (sm_device(array(1:nchars+9)) .lt. 0) then
               write (nwrite,1007) array(1:nchars+9)
1007           format ('FILE OPENING ERROR FOR:',a56)
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         endif
      endif

c curt mode AMcW 1/2000
        if (curt) go to 5

c*****now the option will be to redo the molecular equilibrium and redo
c     the last species, at the user's option.
60    if (neq .ne. 0) then
         iatom = idint(atom1(lim1obs))
         do n=1,neq                                                      
            if (iatom .eq. iorder(n)) then
               write (array,1004)
1004           format ('SPECIES USES MOLEC. EQUILIBRIUM!',
     .               '  REDO WITH NEW AVERAGE ABUNDANCE ([y]/n)? ')
               ikount=kount+11
               nchars = 75
35             call getasci (nchars,ikount)
               choice = chinfo(1:1)
               if (choice.eq.'y' .or. nchars.le.0) then
                  xabund(iatom) = 10.**(average-12.)
                  call eqlib
                  call nearly
                  go to 10
               elseif (choice .eq. 'n') then
                  go to 36
               else
                  go to 35
               endif
            endif
         enddo
      endif
            
c*****quit, or go on to another species?
36    array = 'DO ANOTHER SPECIES ([y]/n)? '
      ikount=kount+11
      nchars = 32
      call getasci (nchars,ikount)
      choice = chinfo(1:1)
      if (choice.eq.'y' .or. nchars.le.0) then
         go to 5
      else
         call finish
         return
      endif


      end








