
      subroutine readobs (line)
c*****this routine reads in observed spectra.  the format is indicated by
c     the value of ipr(9)

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Chars.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 disp(9)
      integer*2 int2(1440)
      integer*4 int4(720)
      real*4 real4(720)
      equivalence (int2,int4)
      equivalence (int2,real4)
      character head*2880

c*****branch to the appropriate data file type
      rewind fileobs
      go to (100,200,300,400,500),ipr(9)

c*****here is a pure FITS file type. First set some default parameters
100   write (obsitle,1021)
1021  format (80(' '))
      naxis = 1
      naxis1 = 0
      bscale = 0.
      bzero = 0.
      do j=1,9
         disp(j) = 0.
      enddo

c     get the header information
      irec = 1
101   read (unit=fileobs,rec=irec,err=1002,iostat=ierr) head
      do 150 j=1,36
         k = 80*(j-1)
         if     (head(k+1:k+8) .eq. 'SIMPLE  ') then
            if (head(k+30:k+30) .ne. 'T') then
               write(array,1029) head(k+1:k+58)
1029           format('ILLEGAL FILE FORMAT: ',a58)
               istat = ivwrite (line+2,3,array,79)
               go to 1007
            endif
         elseif (head(k+1:k+8) .eq. 'BITPIX  ') then
               read (head(k+1:k+80),1025) ibits
1025           format (10x,i20)
               if (ibits .eq. 16) then
                  nblock = 1440
               elseif (ibits .eq. 32) then
                  nblock = 720
               elseif (ibits .eq. -32) then
                  nblock = 720
               else
                  write(array,1026) ibits
1026              format('SORRY: I CANT HANDLE BITPIX=',i4)
                  istat = ivwrite (line+2,3,array,32)
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS   ') then
               read (head(k+1:k+80),1025) naxis
               if (naxis .ne. 1) then
                  write(array,1028) head(k+1:k+58) 
1028              format('ILLEGAL NAXIS ENTRY: ',a58)
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS1  ') then
               read (head(k+1:k+80),1025) lount
         elseif (head(k+1:k+8) .eq. 'OBJECT  ') then
               write (obsitle,1027) head(k+12:k+80)
1027           format (a68)
         elseif (head(k+1:k+8) .eq. 'BZERO   ') then
               read (head(k+1:k+80),1024) bzero
1024           format (10x,d20.10)
         elseif (head(k+1:k+8) .eq. 'BSCALE  ') then
               read (head(k+1:k+80),1024) bscale
         elseif ((head(k+1:k+8) .eq. 'W0      ') .or. 
     .      (head(k+1:k+8) .eq. 'CRVAL1  ')) then
               read (head(k+1:k+80),1024) disp(1)
         elseif ((head(k+1:k+8) .eq. 'WPC     ') .or. 
     .      (head(k+1:k+8) .eq. 'CDELT1  ')) then
               read (head(k+1:k+80),1024) dval
               if (dval .ne. 1.) disp(2) = dval
         elseif (head(k+1:k+8) .eq. 'CD1_1    ') then
               read (head(k+1:k+80),1024) disp(2)
         elseif (head(k+1:k+8) .eq. 'FILENAME') then
               write (obsitle(39:80),1023) head(k+12:k+53)
1023           format (a41)
         elseif (head(k+1:k+8) .eq. 'HISTORY ') then
               if (head(k+24:k+28) .eq. 'DISP=') then
                  read (head(k+1:k+80),1022) (disp(i),i=1,4)
 1022                        format(28x,1p4d13.5)
               elseif (head(k+20:k+26) .eq. 'D1,2,3:') then
                  read (head(k+1:k+80),1042) (disp(i),i=1,3)
               elseif (head(k+20:k+26) .eq. 'D4,5,6:') then
                  read (head(k+1:k+80),1042) (disp(i),i=4,6)
               elseif (head(k+20:k+26) .eq. 'D7,8,9:') then
                  read (head(k+1:k+80),1042) (disp(i),i=7,9)
 1042                        format(26x,1p3d18.11)
                  if (disp(7).ne.0.0 .and. disp(8).eq.0.0 .and.
     .                disp(9).eq.0.0) then
                     disp(8) = 1.0
                     disp(9) = lount
                  endif
               endif
            elseif (head(k+1:k+8) .eq. 'END     ') then
               go to 110
         endif
150   continue
      irec = irec + 1
      go to 101

c     now read the data 
110   nrec = lount/nblock
      ipt = 0
      if (mod(lount,nblock) .ne. 0) nrec = nrec + 1
      do 130 j=1,nrec
         irec = irec + 1
         jpt = min0(nblock,lount-ipt)
         if (ibits .eq. 16) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) int2
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int2(k))
            enddo
         elseif (ibits .eq. 32) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) int4
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int4(k))
            enddo
         elseif(ibits .eq. -32) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) real4
            do k=1,jpt
               yobs(ipt+k) = real4(k)
            enddo
         endif
         ipt = ipt + jpt
130   continue

c     now fill in the wavelength array
      do j=1,lount
         xobs(j) = sngl(wavecalc(real(j),lount,disp))
            write (55,*) j, xobs(j)
      enddo
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif
      return
         
c     give error messages, and abort
1002  write(array,1003) ierr
1003  format('ERROR IN FITS HEADER READ:   ERROR=',i4)
      istat = ivwrite(line+2,3,array,39)
      go to 1007
1006  write(array,1004) ierr
1004  format('ERROR IN DATA READ:  ERROR=',i4,'/')
      istat = ivwrite(line+2,3,array,39)
1007  lount = -1
      return

200   return

300   return

400   return

c*****here is a MONGO-style input array
500   read (fileobs,5001) obsitle
5001  format (a80)
      i = 1
501   read (fileobs,*,end=525) xobs(i),yobs(i)
      i = i + 1
      go to 501
525   lount = i - 1
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif
      return

      end












