
      subroutine stats
c******************************************************************************
c     This routine does abundance statistics for a single species
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'

c*****compute the average and standard deviation
      average = 0.
      kount = 0
      do l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            average = average + abunout(l)
            kount = kount + 1
         endif
      enddo
      if (kount .gt. 0) then
         average = average/kount
      endif
      deviate = 0.
      if (kount .gt. 1) then
         do l=lim1obs,lim2obs
            if (abunout(l) .ne. 999.99) then
               deviate = deviate + (abunout(l)-average)**2
            endif
         enddo
         deviate = dsqrt(deviate/(kount-1))
      endif
         
c*****correlate the abundances with excitation potential and equivalent width
      if (kount .gt. 2) then
         epmin = 999.
         epmax = -999.
         rwmin = 999.
         rwmax = -999.
         x1 = 0.
         x2 = 0.
         x3 = 0.
         x4 = 0.
         y1 = 0.
         y2 = 0.
         xy = 0.
         yz = 0.
         do l=lim1obs,lim2obs
            if (abunout(l) .ne. 999.99) then
               rw = dlog10(width(l)/wave1(l))
               x1 = x1 + e(l,1)
               x2 = x2 + e(l,1)**2
               x3 = x3 + rw
               x4 = x4 + rw**2
               y1 = y1 + abunout(l)
               y2 = y2 + abunout(l)**2
               xy = xy + e(l,1)*abunout(l)
               yz = yz + rw*abunout(l)
               if (e(l,1) .lt. epmin) epmin = e(l,1)
               if (e(l,1) .gt. epmax) epmax = e(l,1)
               if (rw .lt. rwmin) rwmin = rw
               if (rw .gt. rwmax) rwmax = rw
            endif
         enddo
         xxm1 = (kount*xy - x1*y1)/(kount*x2 - x1**2)
         xxb1 = (y1*x2 - xy*x1)/(kount*x2 - x1**2)
         xxr1 = (kount*xy - x1*y1)/dsqrt((kount*x2 - x1**2)*
     .         (kount*y2 - y1**2))
         xxm2 = (kount*yz - x3*y1)/(kount*x4 - x3**2)
         xxb2 = (y1*x4 - yz*x3)/(kount*x4 - x3**2)
         xxr2 = (kount*yz - x3*y1)/dsqrt((kount*x4 - x3**2)*
     .         (kount*y2 - y1**2))
         deltaep = epmax - epmin
         deltarw = rwmax - rwmin
      endif

      return
      end
  

