
      subroutine synspec                                                 
c******************************************************************************
c     This routine does synthetic spectra                                
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'


c*****initialize the synthesis
      call out (11)                                                       
      n = 1                                                              
      nsteps = 1
      lim1line = 0


c*****calculate continuum quantities at the spectrum wavelength
      wave = start
      wavl = 0.
 30   if (dabs(wave-wavl)/wave .ge. 0.001) then
         wavl = wave   
         call opacit (2,wave)    
         call out (15)                         
         call cdcalc (1)  
         first = 0.4343*cd(1)
         flux = rinteg(xref,cd,dummy1,ntau,first)
         call out (10)          
      endif


c*****find the appropriate set of lines for this wavelength, reading 
c     in a new set if needed
      if (mode .eq. 3) then
20       call linlimit
         if (lim2line .lt. 0) then
            call inlines (2)
            call nearly
            go to 20
         endif
         lim1 = lim1line
         lim2 = lim2line
      endif

c*****compute a spectrum depth at this point
      call taukap   
      call cdcalc (2)
      first = 0.4343*cd(1)
      d(n) = rinteg(xref,cd,dummy1,ntau,first)       
      call out (12)                

c*****step in wavelength and try again 
      if (iunits .eq. 2) then
         wave = 1.d8/(oldstop - step*nsteps)
         delta = olddelta/(1.d8/wave**2)
      elseif (iunits .eq. 1) then
         wave = 1.d4*oldstart + step*nsteps
      else
         wave = oldstart + step*nsteps
      endif
      if (wave .le. stop) then
         n = n + 1        
         nsteps = nsteps + 1
         if (n .gt. 5000) n = 1                                      
         go to 30                   

c*****finish the synthesis
      else
         call out (13)                 
         return 
      endif


      end                                




