      subroutine synth                   
c******************************************************************************
c     This program synthesizes a section of spectrum and compares it
c     to an observation file.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20     
      lscreen = 4
c     array = 'Give the filename for standard output: '
c     nchars = 39
c     call infile ('output ',nwrite,'formatted  ',0,nchars,lscreen)

c AMcW 22/Feb/2007
      open(unit=nwrite,file='logfile')

      ndump = 21               
      lscreen = lscreen + 2

c AMcW 22/Feb/2007
      open(unit=ndump,file='OUTPUT')

c     array = 'Give the filename for raw syntheses output: '
c     nchars = 44
c     call infile ('output ',ndump,'formatted  ',0,nchars,lscreen)
      if (ipr(7) .ne. 0) then
         n2dump = 22               
         lscreen = lscreen + 2

c AMcW 22/Feb/2007
      open(unit=n2dump,file='synth.smooth.output')

c        array = 'Give the filename for smoothed syntheses: '
c        nchars = 42
c        call infile ('output ',n2dump,'formatted  ',0,nchars,lscreen)
      endif
c     if (iraf .ne. 0) then
c        n2write = 23               
c        lscreen = lscreen + 2
c        array = 'Give the filename for IRAF ("rtext") output: '
c        nchars = 45
c        call infile ('output ',n2write,'formatted  ',0,nchars,lscreen)
c     endif


c*****set up the model atmosphere                                        
      filemodel = 30
      lscreen = lscreen + 2
c     array = 'Give the filename for the model atmosphere: '
c     nchars = 44
c     call infile ('input  ',filemodel,'formatted  ',0,nchars,lscreen)

c AMcW 22/Feb/2007
      open(unit=filemodel,file='MODEL',status='old')

      call inmodel


c*****open the line list file and the strong line list file
      filelines = 31
      lscreen = lscreen + 2
c     array = 'Give the filename for the line list: '
c     nchars = 37
c     call infile ('input  ',filelines,'formatted  ',0,nchars,lscreen)

c AMcW 22/Feb/2007
      open(unit=filelines,file='INPUT',status='old')

      if (nstrong .gt. 0) then
         fileslines = 32
         lscreen = lscreen + 2
c        array = 'Give the filename for the strong line list: '
c        nchars = 44
c        call infile ('input  ',fileslines,'formatted  ',0,nchars,
c    .                lscreen)


c AMcW 22/Feb/2007
      open(unit=fileslines,file='INPUT.strong',status='old')


      endif
      

c*****do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = 1
            mode = 3
	    if (numiso .ne. 0) call out (26)
            call inlines (1)
            call eqlib
            call nearly
            start = oldstart
            stop = oldstop
            call synspec
            ipr(3) = 0
         enddo
      endif
      call total
         
c
c removed AMcW 22/Feb/2007
c
c*****now plot the spectrum
c     if (ipr(7).eq.2 .and. ipr(9).gt.0) then
c        fileobs = 23               
c        lscreen = lscreen + 2
c        array = 'Give the filename of the observed spectrum: '
c        nchars = 44
c        if (ipr(9) .eq. 1) then
c           call infile ('input  ',fileobs,'unformatted',2880,nchars,
c    .                   lscreen)
c        else
c           call infile ('input  ',fileobs,'formatted  ',0,nchars,
c    .                   lscreen)
c        endif
c     endif
c     if (ipr(7) .ne. 0) then
c        call pltspec (lscreen)
c     endif

c*****finish
      call finish
      return
      end                                                                
